﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication7
{
    public partial class Form1 : Form
    {
        DataSet ds = new DataSet();

        public Form1()
        {
            InitializeComponent();
            {
                DataTable dt = new DataTable();
                dt.TableName = "One";
                dt.Columns.Add("IDOne", typeof(string));
                dt.Columns.Add("field1", typeof(string));
                dt.Columns.Add("field2", typeof(string));
                ds.Tables.Add(dt);
            }

            {
                DataTable dt = new DataTable();
                dt.TableName = "Two";
                dt.Columns.Add("IDOne", typeof(string));
                dt.Columns.Add("field3", typeof(string));
                dt.Columns.Add("field4", typeof(string));
                ds.Tables.Add(dt);
                dt.ParentRelations.Add("Two",ds.Tables["One"].Columns["IDOne"], dt.Columns["IDOne"]);
            }

            {
                DataTable dt = new DataTable();
                dt.TableName = "Three";
                dt.Columns.Add("IDOne", typeof(string));
                dt.Columns.Add("field5", typeof(string));
                dt.Columns.Add("field6", typeof(string));
                ds.Tables.Add(dt);
                dt.ParentRelations.Add("Three", ds.Tables["One"].Columns["IDOne"], dt.Columns["IDOne"]);
            }

            {
                DataRow r = ds.Tables["One"].NewRow();
                r["IDOne"] = "1";
                r["field1"] = "1";
                r["field2"] = "1";
                ds.Tables["One"].Rows.Add(r);

                DataRow r2 = ds.Tables["Two"].NewRow();
                r2["IDOne"] = "1";
                r2["field3"] = "1";
                r2["field4"] = "1";
                ds.Tables["Two"].Rows.Add(r2);
                r2 = ds.Tables["Two"].NewRow();
                r2["IDOne"] = "1";
                r2["field3"] = "2";
                r2["field4"] = "2";
                ds.Tables["Two"].Rows.Add(r2);
            }

            {
                DataRow r = ds.Tables["One"].NewRow();
                r["IDOne"] = "2";
                r["field1"] = "1";
                r["field2"] = "1";
                ds.Tables["One"].Rows.Add(r);

                DataRow r2 = ds.Tables["Three"].NewRow();
                r2["IDOne"] = "2";
                r2["field5"] = "1";
                r2["field6"] = "1";
                ds.Tables["Three"].Rows.Add(r2);
                r2 = ds.Tables["Three"].NewRow();
                r2["IDOne"] = "2";
                r2["field5"] = "2";
                r2["field6"] = "2";
                ds.Tables["Three"].Rows.Add(r2);
            }
            ultraGrid1.DataSource = ds;
            ultraGrid1.Rows.ExpandAll(true);
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ds.Tables["Three"].ParentRelations.Clear();
            ds.Tables["Three"].Constraints.Clear();
            ds.Tables.Remove(ds.Tables["Three"]);

            {
                DataTable dt = new DataTable();
                dt.TableName = "Three";
                dt.Columns.Add("IDOne", typeof(string));
                dt.Columns.Add("field7", typeof(string));
                dt.Columns.Add("field8", typeof(string));
                dt.Columns.Add("field9", typeof(string));
                ds.Tables.Add(dt);
                dt.ParentRelations.Add("Three",ds.Tables["One"].Columns["IDOne"], dt.Columns["IDOne"]);
            }

            {
                DataRow r2 = ds.Tables["Three"].NewRow();
                r2["IDOne"] = "2";
                r2["field7"] = "1";
                r2["field8"] = "1";
                r2["field9"] = "1";
                ds.Tables["Three"].Rows.Add(r2);

                r2 = ds.Tables["Three"].NewRow();
                r2["IDOne"] = "2";
                r2["field7"] = "2";
                r2["field8"] = "2";
                r2["field9"] = "2";
                ds.Tables["Three"].Rows.Add(r2);

                r2 = ds.Tables["Three"].NewRow();
                r2["IDOne"] = "2";
                r2["field7"] = "3";
                r2["field8"] = "3";
                r2["field9"] = "3";
                ds.Tables["Three"].Rows.Add(r2);
                
            }
            
            // How to have datasource structure changes reflected in the grid ???
        }
    }
}
